<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar"  prefix="carbon" %>
<%@page import="org.wso2.carbon.utils.ServerConstants" %>
<%@page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@page import="org.apache.axis2.context.ConfigurationContext" %>
<%@page import="org.wso2.carbon.CarbonConstants" %>
<%@page import="org.wso2.carbon.CarbonError" %>
<%@page import="org.wso2.carbon.identity.user.profile.ui.client.UserProfileCient" %>
<%@page import="java.lang.Exception" %>

<%@page import="org.wso2.carbon.identity.user.profile.ui.types.UserFieldDTO" %>
<%@page import="org.wso2.carbon.identity.user.profile.ui.types.UserProfileDTO" %>

<%@page import="java.util.ResourceBundle"%><script type="text/javascript" src="extensions/js/vui.js"></script>
<script type="text/javascript" src="../extensions/core/js/vui.js"></script>
<script type="text/javascript" src="../admin/js/main.js"></script>

<jsp:include page="../dialog/display_messages.jsp"/>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>

<%
    String username = (String) request.getParameter("username");
    String print = (String) request.getParameter("print");
    UserFieldDTO[] userFields = null;
    UserProfileDTO profile = null;
    String forwardTo = null;
    String[] profileConfigs = null;
	String BUNDLE = "org.wso2.carbon.identity.user.profile.ui.i18n.Resources";
	ResourceBundle resourceBundle = ResourceBundle.getBundle(BUNDLE, request.getLocale());
	
    try {
        String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
        String backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
        ConfigurationContext configContext =
                (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
        UserProfileCient client = new UserProfileCient(cookie, backendServerURL, configContext);
        profile = client.getProfileFieldsForInternalStore();

        if (profile != null) {
            userFields = client.getOrderedUserFields(profile.getFieldValues());
            profileConfigs = profile.getProfileConfigurations();
        }
    } catch (Exception e) {
    	String message = resourceBundle.getString("error.while.loading.user.profile.data");
        CarbonUIMessage.sendCarbonUIMessage(message, CarbonUIMessage.ERROR, request);
        forwardTo = "../admin/error.jsp";
    }
%>

<%
    if ( forwardTo != null) {
%>
<script type="text/javascript">
    function forward() {
        location.href = "<%=forwardTo%>";
    }
</script>

<script type="text/javascript">
    forward();
</script>
<%
    return;
    }
%>


<%@page import="org.wso2.carbon.user.core.UserCoreConstants" %>
<fmt:bundle
        basename="org.wso2.carbon.identity.user.profile.ui.i18n.Resources">
    <carbon:breadcrumb label="add.profile"
                       resourceBundle="org.wso2.carbon.identity.user.profile.ui.i18n.Resources"
                       topPage="false" request="<%=request%>"/>

    <script type="text/javascript" src="../carbon/admin/js/breadcrumbs.js"></script>
    <script type="text/javascript" src="../carbon/admin/js/cookies.js"></script>
    <script type="text/javascript" src="../carbon/admin/js/main.js"></script>

    <div id="middle">
        <%if ("true".equals(print)) {%>
        <h2><fmt:message key='add.new.profile1'/><%=username%></h2>
        <%} else {%>
        <h2><fmt:message key='add.new.profile2'/></h2>
        <%}%>

        <div id="workArea">
            <script type="text/javascript">
                function validate() {
                    var value = document.getElementsByName("profile")[0].value;
                    if (value == '') {
                        CARBON.showWarningDialog('<fmt:message key="user.profilename.is.required"/>');
                        return false;
                    }

                <%if (userFields!=null) {
                    for (int i=0; i< userFields.length;i++) { %>
                    var value = document.getElementsByName("<%=userFields[i].getClaimUri()%>")[0].value;
                <% if (userFields[i].getRequired()&& userFields[i].getDisplayName()!=null) {%>
                    if (validateEmpty("<%=userFields[i].getClaimUri()%>").length > 0) {
                        CARBON.showWarningDialog("<%=userFields[i].getDisplayName()%>" + " <fmt:message key='is.required'/>");
                        return false;
                    }
                <%}

                if(userFields[i].getRegEx() != null){
                %>
                    var reg = new RegExp("<%=userFields[i].getRegEx() %>");
                    var valid = reg.test(value);
                    if (value != '' && !valid) {
                        CARBON.showWarningDialog("<%=userFields[i].getDisplayName()%>" + " <fmt:message key='is.not.valid'/>");
                        return false;
                    }
                <%}
              }
              }%>

                    document.addProfileform.submit();
                }
            </script>

            <form method="post" name="addProfileform" action="set-finish.jsp?print=<%=print%>"
                  target="_self">
                <input type="hidden" name="username" value="<%=username%>"/>
                <table style="width: 100%" class="styledLeft">
                    <thead>
                    <tr>
                        <th><fmt:message key='user.profile'/></th>
                    </tr>
                    </thead>
                    <tbody>
		    <tr>
			<td class="formRow">
				<table class="normal" >
		                    <tr>
		                        <td class="leftCol-small"><fmt:message key='profile.name'/><font class="required">*</font></td>
		                        <td><input class="text-box-big" id="profile" name="profile"
		                                   type="text" /></td>
		                    </tr>
		                    <%if (profileConfigs != null && profileConfigs.length > 0 && profileConfigs[0] != null) { %>
		                    <tr>
		                        <td class="leftCol-small"><fmt:message key='profile.cofiguration'/></td>
		                        <td>
		                            <select name="profileConfiguration">
		                                <%for (int i = 0; i < profileConfigs.length; i++) { %>
		                                <%if (UserCoreConstants.DEFAULT_PROFILE_CONFIGURATION.equals(profileConfigs[i])) { %>
		                                <option value="<%=profileConfigs[i]%>" selected="selected"><%=profileConfigs[i] %>
		                                </option>
		                                <%} else { %>
		                                <option value="<%=profileConfigs[i]%>"><%=profileConfigs[i]%>
		                                </option>
		                                <%
		                                        }
		                                    }
		                                %>
		                            </select>
		                        </td>
		                    </tr>
		                    <%} %>
		                    <% if (userFields != null) {
		                        for (int i = 0; i < userFields.length; i++) {
		                    %>
		                    <%if (userFields[i].getDisplayName() != null) {%>
		                    <tr>
		                        <td class="leftCol-small"><%=userFields[i].getDisplayName()%> <% if (userFields[i].getRequired()) {%>
		                            <font class="required">*</font> <%}%>
		                        </td>
		                        <td><input class="text-box-big"
		                                   id="<%=userFields[i].getClaimUri()%>"
		                                   name="<%=userFields[i].getClaimUri()%>" type="text"></td>
		                    </tr>
		                    <%
		                                }
		                            }
		                        }
		                    %>
		
				</table>
			</td>
		    </tr>
                    <tr>
                        <td class="buttonRow" >
                            <input name="addprofile" type="button" class="button" value="<fmt:message key='add'/>" onclick="validate();"/>
                            <input type="button" class="button"
                                  <%if ("true".equals(print)) {%>
                                   onclick="javascript:location.href='index.jsp?region=region5&item=userprofiles_menu&ordinal=0&username=<%=username%>'"
                                  <%}else{%>
                                   onclick="javascript:location.href='index.jsp?region=region5&item=userprofiles_menu&ordinal=0'"
                                  <%}%>
                                   value="<fmt:message key='cancel'/>"/></td>
                    </tr>
                    </tbody>
                </table>

            </form>
        </div>
    </div>
</fmt:bundle>

